'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _base = require('../serializers/base-64');

var _base2 = _interopRequireDefault(_base);

var _key = require('../utils/key');

var _key2 = _interopRequireDefault(_key);

var _node = require('./node');

var _node2 = _interopRequireDefault(_node);

var _offsetKey = require('../utils/offset-key');

var _offsetKey2 = _interopRequireDefault(_offsetKey);

var _raw = require('../serializers/raw');

var _raw2 = _interopRequireDefault(_raw);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _selection = require('../models/selection');

var _selection2 = _interopRequireDefault(_selection);

var _types = require('../utils/types');

var _types2 = _interopRequireDefault(_types);

var _includes = require('lodash/includes');

var _includes2 = _interopRequireDefault(_includes);

var _keycode = require('keycode');

var _keycode2 = _interopRequireDefault(_keycode);

var _environment = require('../utils/environment');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Noop.
 *
 * @type {Function}
 */

function noop() {}

/**
 * Content.
 *
 * @type {Component}
 */

var Content = function (_React$Component) {
  _inherits(Content, _React$Component);

  /**
   * Constructor.
   *
   * @param {Object} props
   */

  /**
   * Property types.
   *
   * @type {Object}
   */

  function Content(props) {
    _classCallCheck(this, Content);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Content).call(this, props));

    _initialiseProps.call(_this);

    _this.tmp = {};
    _this.tmp.compositions = 0;
    _this.forces = 0;
    return _this;
  }

  /**
   * Should the component update?
   *
   * @param {Object} props
   * @param {Object} state
   * @return {Boolean} shouldUpdate
   */

  /**
   * Default properties.
   *
   * @type {Object}
   */

  /**
   * While rendering, set the `isRendering` flag.
   *
   * @param {Object} props
   * @param {Object} state]
   */

  /**
   * When finished rendering, move the `isRendering` flag on next tick.
   *
   * @param {Object} props
   * @param {Object} state]
   */

  _createClass(Content, [{
    key: 'getPoint',


    /**
     * Get a point from a native selection's DOM `element` and `offset`.
     *
     * @param {Element} element
     * @param {Number} offset
     * @return {Object}
     */

    value: function getPoint(element, offset) {
      var offsetKey = _offsetKey2.default.findKey(element, offset);
      var ranges = this.getRanges(offsetKey.key);
      var point = _offsetKey2.default.findPoint(offsetKey, ranges);
      return point;
    }

    /**
     * Get the ranges for a text node by `key`.
     *
     * @param {String} key
     * @return {List}
     */

  }, {
    key: 'getRanges',
    value: function getRanges(key) {
      var _props = this.props;
      var state = _props.state;
      var renderDecorations = _props.renderDecorations;

      var node = state.document.getDescendant(key);
      var block = state.document.getClosestBlock(node);
      var ranges = node.getDecoratedRanges(block, renderDecorations);
      return ranges;
    }

    /**
     * On before input, bubble up.
     *
     * @param {Event} e
     */

    /**
     * On blur, update the selection to be not focused.
     *
     * @param {Event} e
     */

    /**
     * On change, bubble up.
     *
     * @param {State} state
     */

    /**
     * On composition start, set the `isComposing` flag.
     *
     * @param {Event} e
     */

    /**
     * On composition end, remove the `isComposing` flag on the next tick. Also
     * increment the `forces` key, which will force the contenteditable element
     * to completely re-render, since IME puts React in an unreconcilable state.
     *
     * @param {Event} e
     */

    /**
     * On copy, defer to `onCutCopy`, then bubble up.
     *
     * @param {Event} e
     */

    /**
     * On cut, defer to `onCutCopy`, then bubble up.
     *
     * @param {Event} e
     */

    /**
     * On cut and copy, add the currently selected fragment to the currently
     * selected DOM, so that it will show up when pasted.
     *
     * @param {Event} e
     */

    /**
     * On drag end, unset the `isDragging` flag.
     *
     * @param {Event} e
     */

    /**
     * On drag over, set the `isDragging` flag and the `isInternalDrag` flag.
     *
     * @param {Event} e
     */

    /**
     * On drag start, set the `isDragging` flag and the `isInternalDrag` flag.
     *
     * @param {Event} e
     */

    /**
     * On drop.
     *
     * @param {Event} e
     */

    /**
     * On input, handle spellcheck and other similar edits that don't go trigger
     * the `onBeforeInput` and instead update the DOM directly.
     *
     * @param {Event} e
     */

    /**
     * On key down, prevent the default behavior of certain commands that will
     * leave the editor in an out-of-sync state, then bubble up.
     *
     * @param {Event} e
     */

    /**
     * On paste, determine the type and bubble up.
     *
     * @param {Event} e
     */

    /**
     * On select, update the current state's selection.
     *
     * @param {Event} e
     */

    /**
     * Render the editor content.
     *
     * @return {Element} element
     */

    /**
     * Render a `node`.
     *
     * @param {Node} node
     * @return {Element} element
     */

  }]);

  return Content;
}(_react2.default.Component);

/**
 * Export.
 */

Content.propTypes = {
  className: _react2.default.PropTypes.string,
  editor: _react2.default.PropTypes.object.isRequired,
  onBeforeInput: _react2.default.PropTypes.func.isRequired,
  onChange: _react2.default.PropTypes.func.isRequired,
  onKeyDown: _react2.default.PropTypes.func.isRequired,
  onPaste: _react2.default.PropTypes.func.isRequired,
  onSelect: _react2.default.PropTypes.func.isRequired,
  readOnly: _react2.default.PropTypes.bool.isRequired,
  renderDecorations: _react2.default.PropTypes.func.isRequired,
  renderMark: _react2.default.PropTypes.func.isRequired,
  renderNode: _react2.default.PropTypes.func.isRequired,
  spellCheck: _react2.default.PropTypes.bool.isRequired,
  state: _react2.default.PropTypes.object.isRequired,
  style: _react2.default.PropTypes.object
};
Content.defaultProps = {
  style: {}
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.shouldComponentUpdate = function (props, state) {
    return props.className != _this2.props.className || props.readOnly != _this2.props.readOnly || props.spellCheck != _this2.props.spellCheck || props.style != _this2.props.style || props.state.isNative !== true;
  };

  this.componentWillUpdate = function (props, state) {
    _this2.tmp.isRendering = true;
  };

  this.componentDidUpdate = function (props, state) {
    setTimeout(function () {
      _this2.tmp.isRendering = false;
    });
  };

  this.onBeforeInput = function (e) {
    if (_this2.props.readOnly) return;
    _this2.props.onBeforeInput(e);
  };

  this.onBlur = function (e) {
    if (_this2.props.readOnly) return;
    if (_this2.tmp.isCopying) return;
    var state = _this2.props.state;


    state = state.transform().blur().apply({ isNative: true });

    _this2.onChange(state);
  };

  this.onChange = function (state) {
    _this2.props.onChange(state);
  };

  this.onCompositionStart = function (e) {
    _this2.tmp.isComposing = true;
    _this2.tmp.compositions++;
  };

  this.onCompositionEnd = function (e) {
    _this2.forces++;
    var count = _this2.tmp.compositions;

    // The `count` check here ensures that if another composition starts
    // before the timeout has closed out this one, we will abort unsetting the
    // `isComposing` flag, since a composition in still in affect.
    setTimeout(function () {
      if (_this2.tmp.compositions > count) return;
      _this2.tmp.isComposing = false;
    });
  };

  this.onCopy = function (e) {
    _this2.onCutCopy(e);
  };

  this.onCut = function (e) {
    if (_this2.props.readOnly) return;
    _this2.onCutCopy(e);

    // Once the cut has successfully executed, delete the current selection.
    window.requestAnimationFrame(function () {
      var state = _this2.props.state.transform().delete().apply();
      _this2.onChange(state);
    });
  };

  this.onCutCopy = function (e) {
    var native = window.getSelection();
    if (!native.rangeCount) return;

    var state = _this2.props.state;
    var fragment = state.fragment;

    var encoded = _base2.default.serializeNode(fragment);

    // Wrap the first character of the selection in a span that has the encoded
    // fragment attached as an attribute, so it will show up in the copied HTML.
    var range = native.getRangeAt(0);
    var contents = range.cloneContents();
    var wrapper = window.document.createElement('span');
    var text = contents.childNodes[0];
    var char = text.textContent.slice(0, 1);
    var first = window.document.createTextNode(char);
    var rest = text.textContent.slice(1);
    text.textContent = rest;
    wrapper.appendChild(first);
    wrapper.setAttribute('data-fragment', encoded);
    contents.insertBefore(wrapper, text);

    // Add the phony content to the DOM, and select it, so it will be copied.
    var body = window.document.querySelector('body');
    var div = window.document.createElement('div');
    div.setAttribute('contenteditable', true);
    div.style.position = 'absolute';
    div.style.left = '-9999px';
    div.appendChild(contents);
    body.appendChild(div);

    // Set the `isCopying` flag, so our `onSelect` logic doesn't fire.
    _this2.tmp.isCopying = true;
    var r = window.document.createRange();
    // COMPAT: In Firefox, trying to use the terser `native.selectAllChildren`
    // throws an error, so we use the older `range` equivalent. (2016/06/21)
    r.selectNodeContents(div);
    native.removeAllRanges();
    native.addRange(r);

    // Revert to the previous selection right after copying.
    window.requestAnimationFrame(function () {
      body.removeChild(div);
      native.removeAllRanges();
      native.addRange(range);
      _this2.tmp.isCopying = false;
    });
  };

  this.onDragEnd = function (e) {
    _this2.tmp.isDragging = false;
    _this2.tmp.isInternalDrag = null;
  };

  this.onDragOver = function (e) {
    var data = e.nativeEvent.dataTransfer;
    // COMPAT: In Firefox, `types` is array-like. (2016/06/21)
    var types = Array.from(data.types);

    // Prevent default when nodes are dragged to allow dropping.
    if ((0, _includes2.default)(types, _types2.default.NODE)) {
      e.preventDefault();
    }

    if (_this2.tmp.isDragging) return;
    _this2.tmp.isDragging = true;
    _this2.tmp.isInternalDrag = false;
  };

  this.onDragStart = function (e) {
    _this2.tmp.isDragging = true;
    _this2.tmp.isInternalDrag = true;
    var data = e.nativeEvent.dataTransfer;
    // COMPAT: In Firefox, `types` is array-like. (2016/06/21)
    var types = Array.from(data.types);

    // If it's a node being dragged, the data type is already set.
    if ((0, _includes2.default)(types, _types2.default.NODE)) return;

    var state = _this2.props.state;
    var fragment = state.fragment;

    var encoded = _base2.default.serializeNode(fragment);
    data.setData(_types2.default.FRAGMENT, encoded);
  };

  this.onDrop = function (e) {
    if (_this2.props.readOnly) return;
    e.preventDefault();

    var _props2 = _this2.props;
    var state = _props2.state;
    var renderDecorations = _props2.renderDecorations;
    var selection = state.selection;

    var data = e.nativeEvent.dataTransfer;
    var drop = {};

    // COMPAT: In Firefox, `types` is array-like. (2016/06/21)
    var types = Array.from(data.types);

    // Resolve the point where the drop occured.
    var _e$nativeEvent = e.nativeEvent;
    var x = _e$nativeEvent.x;
    var y = _e$nativeEvent.y;

    var range = void 0;

    // COMPAT: In Firefox, `caretRangeFromPoint` doesn't exist. (2016/07/25)
    if (window.document.caretRangeFromPoint) {
      range = window.document.caretRangeFromPoint(x, y);
    } else {
      range = window.document.createRange();
      range.setStart(e.nativeEvent.rangeParent, e.nativeEvent.rangeOffset);
    }

    var startNode = range.startContainer;
    var startOffset = range.startOffset;
    var point = _this2.getPoint(startNode, startOffset);
    var target = _selection2.default.create({
      anchorKey: point.key,
      anchorOffset: point.offset,
      focusKey: point.key,
      focusOffset: point.offset,
      isFocused: true
    });

    // If the target is inside a void node, abort.
    if (state.document.hasVoidParent(point.key)) return;

    // Handle Slate fragments.
    if ((0, _includes2.default)(types, _types2.default.FRAGMENT)) {
      var encoded = data.getData(_types2.default.FRAGMENT);
      var fragment = _base2.default.deserializeNode(encoded);
      drop.type = 'fragment';
      drop.fragment = fragment;
      drop.isInternal = _this2.tmp.isInternalDrag;
    }

    // Handle Slate nodes.
    else if ((0, _includes2.default)(types, _types2.default.NODE)) {
        var _encoded = data.getData(_types2.default.NODE);
        var node = _base2.default.deserializeNode(_encoded);
        drop.type = 'node';
        drop.node = node;
        drop.isInternal = _this2.tmp.isInternalDrag;
      }

      // Handle files.
      else if (data.files.length) {
          drop.type = 'files';
          drop.files = data.files;
        }

        // Handle HTML.
        else if ((0, _includes2.default)(types, _types2.default.HTML)) {
            drop.type = 'html';
            drop.text = data.getData(_types2.default.TEXT);
            drop.html = data.getData(_types2.default.HTML);
          }

          // Handle plain text.
          else {
              drop.type = 'text';
              drop.text = data.getData(_types2.default.TEXT);
            }

    drop.data = data;
    drop.target = target;
    drop.effect = data.dropEffect;
    _this2.props.onDrop(e, drop);
  };

  this.onInput = function (e) {
    var _props3 = _this2.props;
    var state = _props3.state;
    var renderDecorations = _props3.renderDecorations;
    var _state = state;
    var selection = _state.selection;

    var native = window.getSelection();
    var anchorNode = native.anchorNode;
    var anchorOffset = native.anchorOffset;
    var focusOffset = native.focusOffset;

    var point = _this2.getPoint(anchorNode, anchorOffset);
    var key = point.key;
    var index = point.index;
    var start = point.start;
    var end = point.end;

    var ranges = _this2.getRanges(key);
    var range = ranges.get(index);
    var text = range.text;
    var marks = range.marks;
    var textContent = anchorNode.textContent;

    // COMPAT: If the DOM text ends in a new line, we will have added one to
    // account for browsers collapsing a single one, so remove it.

    if (textContent.charAt(textContent.length - 1) == '\n') {
      textContent = textContent.slice(0, -1);
    }

    // If the text is no different, abort.
    if (textContent == text) return;

    // Determine what the selection should be after changing the text.
    var delta = textContent.length - text.length;
    var after = selection.collapseToEnd().moveForward(delta);

    // Create an updated state with the text replaced.
    state = state.transform().moveTo({
      anchorKey: key,
      anchorOffset: start,
      focusKey: key,
      focusOffset: end
    }).delete().insertText(textContent, marks).moveTo(after).apply();

    // Change the current state.
    _this2.onChange(state);
  };

  this.onKeyDown = function (e) {
    if (_this2.props.readOnly) return;
    var key = (0, _keycode2.default)(e.which);

    if (_this2.tmp.isComposing && (key == 'left' || key == 'right' || key == 'up' || key == 'down')) {
      e.preventDefault();
      return;
    }

    if (key == 'enter' || key == 'backspace' || key == 'delete' || key == 'b' && _key2.default.isCommand(e) || key == 'i' && _key2.default.isCommand(e) || key == 'y' && _key2.default.isWindowsCommand(e) || key == 'z' && _key2.default.isCommand(e)) {
      e.preventDefault();
    }

    _this2.props.onKeyDown(e);
  };

  this.onPaste = function (e) {
    if (_this2.props.readOnly) return;
    e.preventDefault();

    var data = e.clipboardData;
    var paste = {};

    // COMPAT: In Firefox, `types` is array-like. (2016/06/21)
    var types = Array.from(data.types);

    // Handle files.
    if (data.files.length) {
      paste.type = 'files';
      paste.files = data.files;
    }

    // Treat it as rich text if there is HTML content.
    else if ((0, _includes2.default)(types, _types2.default.HTML)) {
        paste.type = 'html';
        paste.text = data.getData(_types2.default.TEXT);
        paste.html = data.getData(_types2.default.HTML);
      }

      // Treat everything else as plain text.
      else {
          paste.type = 'text';
          paste.text = data.getData(_types2.default.TEXT);
        }

    // If html, and the html includes a `data-fragment` attribute, it's actually
    // a raw-serialized JSON fragment from a previous cut/copy, so deserialize
    // it and insert it normally.
    if (paste.type == 'html' && ~paste.html.indexOf('<span data-fragment="')) {
      var regexp = /data-fragment="([^\s]+)"/;
      var matches = regexp.exec(paste.html);

      var _matches = _slicedToArray(matches, 2);

      var full = _matches[0];
      var encoded = _matches[1];

      var fragment = _base2.default.deserializeNode(encoded);
      var state = _this2.props.state;


      state = state.transform().insertFragment(fragment).apply();

      _this2.onChange(state);
      return;
    }

    paste.data = data;
    _this2.props.onPaste(e, paste);
  };

  this.onSelect = function (e) {
    if (_this2.props.readOnly) return;
    if (_this2.tmp.isRendering) return;
    if (_this2.tmp.isCopying) return;
    if (_this2.tmp.isComposing) return;

    var _props4 = _this2.props;
    var state = _props4.state;
    var renderDecorations = _props4.renderDecorations;
    var document = state.document;
    var selection = state.selection;

    var native = window.getSelection();
    var select = {};

    // If there are no ranges, the editor was blurred natively.
    if (!native.rangeCount) {
      select.selection = selection.merge({ isFocused: false });
      select.isNative = true;
    }

    // Otherwise, determine the Slate selection from the native one.
    else {
        var anchorNode = native.anchorNode;
        var anchorOffset = native.anchorOffset;
        var focusNode = native.focusNode;
        var focusOffset = native.focusOffset;

        var anchor = _this2.getPoint(anchorNode, anchorOffset);
        var focus = _this2.getPoint(focusNode, focusOffset);

        // COMPAT: In Firefox, and potentially other browsers, sometimes a select
        // event will fire that resolves to the same location as the current
        // selection, so we can ignore it.
        if (anchor.key == selection.anchorKey && anchor.offset == selection.anchorOffset && focus.key == selection.focusKey && focus.offset == selection.focusOffset) {
          return;
        }

        // If the native selection is inside text nodes, we can trust the native
        // state and not need to re-render.
        select.isNative = anchorNode.nodeType == 3 && focusNode.nodeType == 3;

        select.selection = selection.merge({
          anchorKey: anchor.key,
          anchorOffset: anchor.offset,
          focusKey: focus.key,
          focusOffset: focus.offset,
          isFocused: true
        });
      }

    _this2.props.onSelect(e, select);
  };

  this.render = function () {
    var _props5 = _this2.props;
    var className = _props5.className;
    var readOnly = _props5.readOnly;
    var state = _props5.state;
    var document = state.document;

    var children = document.nodes.map(function (node) {
      return _this2.renderNode(node);
    }).toArray();

    var style = _extends({
      // Prevent the default outline styles.
      outline: 'none',
      // Preserve adjacent whitespace and new lines.
      whiteSpace: 'pre-wrap',
      // Allow words to break if they are too long.
      wordWrap: 'break-word'
    }, readOnly ? {} : { WebkitUserModify: 'read-write-plaintext-only' }, _this2.props.style);

    // COMPAT: In Firefox, spellchecking can remove entire wrapping elements
    // including inline ones like `<a>`, which is jarring for the user but also
    // causes the DOM to get into an irreconilable state.
    var spellCheck = _environment.IS_FIREFOX ? false : _this2.props.spellCheck;

    return _react2.default.createElement(
      'div',
      {
        key: 'slate-content-' + _this2.forces,
        contentEditable: !readOnly,
        suppressContentEditableWarning: true,
        className: className,
        onBeforeInput: _this2.onBeforeInput,
        onBlur: _this2.onBlur,
        onCompositionEnd: _this2.onCompositionEnd,
        onCompositionStart: _this2.onCompositionStart,
        onCopy: _this2.onCopy,
        onCut: _this2.onCut,
        onDragEnd: _this2.onDragEnd,
        onDragOver: _this2.onDragOver,
        onDragStart: _this2.onDragStart,
        onDrop: _this2.onDrop,
        onInput: _this2.onInput,
        onKeyDown: _this2.onKeyDown,
        onKeyUp: noop,
        onPaste: _this2.onPaste,
        onSelect: _this2.onSelect,
        spellCheck: spellCheck,
        style: style
      },
      children
    );
  };

  this.renderNode = function (node) {
    var _props6 = _this2.props;
    var editor = _props6.editor;
    var renderDecorations = _props6.renderDecorations;
    var renderMark = _props6.renderMark;
    var renderNode = _props6.renderNode;
    var state = _props6.state;

    return _react2.default.createElement(_node2.default, {
      key: node.key,
      node: node,
      state: state,
      editor: editor,
      renderDecorations: renderDecorations,
      renderMark: renderMark,
      renderNode: renderNode
    });
  };
};

exports.default = Content;