'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _base = require('../serializers/base-64');

var _base2 = _interopRequireDefault(_base);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _types = require('../utils/types');

var _types2 = _interopRequireDefault(_types);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Draggable.
 *
 * @type {Component}
 */

var Draggable = function (_React$Component) {
  _inherits(Draggable, _React$Component);

  function Draggable() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, Draggable);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Draggable)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.shouldComponentUpdate = function (props) {
      return props.node != _this.props.node || props.state.selection.hasEdgeIn(props.node);
    }, _this.onDragStart = function (e) {
      var node = _this.props.node;

      var encoded = _base2.default.serializeNode(node);
      var data = e.nativeEvent.dataTransfer;
      data.setData(_types2.default.NODE, encoded);
    }, _this.render = function () {
      var _this$props = _this.props;
      var children = _this$props.children;
      var node = _this$props.node;
      var className = _this$props.className;
      var style = _this$props.style;

      var Tag = node.kind == 'block' ? 'div' : 'span';
      return _react2.default.createElement(
        Tag,
        {
          draggable: true,
          onDragStart: _this.onDragStart,
          className: className,
          style: style
        },
        children
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Draggable;
}(_react2.default.Component);

/**
 * Export.
 */

Draggable.propTypes = {
  children: _react2.default.PropTypes.any.isRequired,
  className: _react2.default.PropTypes.string,
  editor: _react2.default.PropTypes.object.isRequired,
  node: _react2.default.PropTypes.object.isRequired,
  state: _react2.default.PropTypes.object.isRequired,
  style: _react2.default.PropTypes.object
};
Draggable.defaultProps = {
  style: {}
};
exports.default = Draggable;